package com.ruoyi.bst.area.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.bst.area.domain.Area;
import com.ruoyi.bst.area.domain.AreaQuery;
import com.ruoyi.bst.area.domain.AreaVO;
import com.ruoyi.common.domain.vo.LongIntegerVO;

/**
 * 运营区Mapper接口
 *
 * @author ruoyi
 * @date 2025-03-14
 */
public interface AreaMapper
{
    /**
     * 查询运营区
     *
     * @param id 运营区主键
     * @return 运营区
     */
    AreaVO selectAreaById(Long id);

    /**
     * 查询运营区列表
     *
     * @param query 运营区
     * @return 运营区集合
     */
    List<AreaVO> selectAreaList(@Param("query")AreaQuery query);

    /**
     * 新增运营区
     *
     * @param area 运营区
     * @return 结果
     */
    int insertArea(Area area);

    /**
     * 修改运营区
     *
     * @param area 运营区
     * @return 结果
     */

    public int updateArea(@Param("data") Area area);

    /**
     * 删除运营区
     *
     * @param id 运营区主键
     * @return 结果
     */
    int deleteAreaById(Long id);

    /**
     * 批量删除运营区
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteAreaByIds(Long[] ids);

    /**
     * 根据查询条件查询运营区ID
     * @param query 查询条件
     * @return 运营区ID
     */
    List<Long> selectIdByQuery(@Param("query") AreaQuery query);

    /**
     * 逻辑删除运营区
     *
     * @param ids 需要删除的运营区主键集合
     * @return 结果
     */
    int logicDel(@Param("ids") List<Long> ids);


    public Long selectAreaByStoreId(Long storeId);

    /**
     * 查询运营区数量
     * @param query
     * @return
     */
    int selectCount(@Param("query") AreaQuery query);

    /**
     * 查询运营区简单数据
     */
    List<AreaVO> selectSimpleList(@Param("query") AreaQuery query);

    /**
     * 查询设备数量最多的运营区ID
     * @param query
     * @return
     */
    List<LongIntegerVO> selectDeviceCountGroupByAreaId(@Param("query") AreaQuery query);

}
